close all;
clear;
clc;

%aquisio de dados

%dados temporais
%Teste2:
Fs_t2 = 28393/(2*60+24.89);            % Frequncia da amostra                  
T_t2 = 1/Fs_t2;                            % Perodo da amostra     
L_t2 = 28393;                            % Comprimento do signal
t_t2 = (0:L_t2-1)*T_t2;                   % Time vector

%Teste1:
Fs_t1 = 23420/(2*60+16.8);                 
T_t1 = 1/Fs_t1;    
L_t1 = 23420;
t_t1 = (0:L_t1-1)*T_t1;


%dados acelermetro (triaxial) - OFF
%t2 = xlsread('t2.xlsx','B1:D28393');
%t1 = xlsread('t1.xlsx','B1:D23420');

%dados acelermetro
t2_x = xlsread('t2.xlsx','B1:B28393');
t1_x = xlsread('t1.xlsx','B1:B23420');

t2_y = xlsread('t2.xlsx','C1:C28393');
t1_y = xlsread('t1.xlsx','C1:C23420');

t2_z = xlsread('t2.xlsx','D1:D28393');
t1_z = xlsread('t1.xlsx','D1:D23420');


%Multidimensional inverse fast Fourier transform - OFF 
%t2_3dfft = ifftn(t2);
%t1_3dfft = ifftn(t1);

%fft
t2_x_fft = fft(t2_x);
t2_y_fft = fft(t2_y);
t2_z_fft = fft(t2_z);

t1_x_fft = fft(t1_x);
t1_y_fft = fft(t1_y);
t1_z_fft = fft(t1_z);

%Calculo dos limites do grfico de acelerao
maxAcel_2 = max (t2_x);
if maxAcel_2 < max (t2_y)
    maxAcel_2 = max (t2_y);
elseif maxAcel_2 < max (t2_z)
    maxAcel_2 = max (t2_z);
end

minAcel_2 = min (t2_x);
if minAcel_2 > min (t2_y)
    minAcel_2 = min (t2_y);
elseif minAcel_2 > min (t2_z)
    minAcel_2 = min (t2_z);
end

if (ceil (maxAcel_2) <= (-floor (minAcel_2)))
    limAcel_2 = -floor (minAcel_2)+0.2;
else
    limAcel_2 = ceil(maxAcel_2)+0.2;
end



%Plotagem acelerao
%teste 2
figure(1)
plot(t_t2,t2_x)
axis([50 140 -limAcel_2 limAcel_2])
title('Teste 2: Acelerao Eixo X')
xlabel('t (segundos)')
ylabel('Gs')

%pause
figure(2)
plot(t_t2,t2_y)
title('Teste 2: Acelerao Eixo Y')
axis([50 140 -limAcel_2 limAcel_2])
xlabel('t (segundos)')
ylabel('Gs')

%pause
figure(3)
plot(t_t2,t2_z)
title('Teste 2: Acelerao Eixo Z')
axis([50 140 -limAcel_2 limAcel_2])
xlabel('t (segundos)')
ylabel('Gs')


%pause 


%teste 1
figure(4)
plot(t_t1,t1_x)
axis([50 140 -limAcel_2 limAcel_2])
title('Teste 1: Acelerao Eixo X')
xlabel('t (segundos)')
ylabel('Gs')

%pause
figure(5)
plot(t_t1,t1_y)
axis([50 140 -limAcel_2 limAcel_2])
title('Teste 1: Acelerao Eixo Y')
xlabel('t (segundos)')
ylabel('Gs')

%pause
figure(6)
plot(t_t1,t1_z)
axis([50 140 -limAcel_2 limAcel_2])
title('Teste 1: Acelerao Eixo Z')
xlabel('t (segundos)')
ylabel('Gs')


%Computando o espectro bilateral
%teste2
P2_t2_x = abs(t2_x_fft/L_t2);
P1_t2_x = P2_t2_x(1:L_t2/2+1);
P1_t2_x(2:end-1) = 2*P1_t2_x(2:end-1);

P2_t2_y = abs(t2_y_fft/L_t2);
P1_t2_y = P2_t2_y(1:L_t2/2+1);
P1_t2_y(2:end-1) = 2*P1_t2_y(2:end-1);

P2_t2_z = abs(t2_z_fft/L_t2);
P1_t2_z = P2_t2_z(1:L_t2/2+1);
P1_t2_z(2:end-1) = 2*P1_t2_z(2:end-1);


%teste1
P2_t1_x = abs(t1_x_fft/L_t1);
P1_t1_x = P2_t1_x(1:L_t1/2+1);
P1_t1_x(2:end-1) = 2*P1_t1_x(2:end-1);

P2_t1_y = abs(t1_y_fft/L_t1);
P1_t1_y = P2_t1_y(1:L_t1/2+1);
P1_t1_y(2:end-1) = 2*P1_t1_y(2:end-1);

P2_t1_z = abs(t1_z_fft/L_t1);
P1_t1_z = P2_t1_z(1:L_t1/2+1);
P1_t1_z(2:end-1) = 2*P1_t1_z(2:end-1);



%definindo o domnio de frequencia
f_t2 = Fs_t2*(0:(L_t2/2))/L_t2;
f_t1 = Fs_t1*(0:(L_t1/2))/L_t1;





%limpando o primeiro valor das frequencias (w=0)
P1_t2_x (1,1) = 0;
P1_t2_y (1,1) = 0;
P1_t2_z (1,1) = 0;

P1_t1_x (1,1) = 0;
P1_t1_y (1,1) = 0;
P1_t1_z (1,1) = 0;



%Calculo dos limites do grfico do espectro de amplitude
maxEsp_2 = max (P1_t2_x);
if maxEsp_2 < max (P1_t2_y)
    maxEsp_2 = max (P1_t2_y);
elseif maxEsp_2 < max (P1_t2_z)
    maxEsp_2 = max (P1_t2_z);
end

minEsp_2 = min (P1_t2_x);
if minEsp_2 > min (P1_t2_y)
    minEsp_2 = min (P1_t2_y);
elseif minEsp_2 > min (P1_t2_z)
    minEsp = min (P1_t2_z);
end

if (maxEsp_2 <= -minEsp_2)
    limEsp_2 = minEsp_2+0.02;
else
    limEsp_2 = maxEsp_2+0.02;
end

mFreq_2 = max(f_t2);



%plotando o espectro de amplitude unilateral
%teste2
figure(7)
plot(f_t2,P1_t2_x)
axis([0 mFreq_2 0 limEsp_2])
title('Teste 2: Espectro de Amplitude unilateral - Eixo X')
xlabel('f (Hz)')
ylabel('|Gs|')
%%
%pause
figure(8)
plot(f_t2,P1_t2_y) 
axis([0 mFreq_2 0 limEsp_2])
title('Teste 2: Espectro de Amplitude unilateral - Eixo Y')
xlabel('f (Hz)')
ylabel('|Gs|')

%%
%pause
figure(9)
plot(f_t2,P1_t2_z)
axis([0 mFreq_2 0 limEsp_2])
title('Teste 2: Espectro de Amplitude unilateral - Eixo Z')
xlabel('f (Hz)')
ylabel('|Gs|')

%pause

%teste1,
figure(10)
plot(f_t1,P1_t1_x)
axis([0 mFreq_2 0 limEsp_2])
title('Teste 1: Espectro de Amplitude unilateral - Eixo X')
xlabel('f (Hz)')
ylabel('|Gs|')

%pause
figure(11)
plot(f_t1,P1_t1_y) 
axis([0 mFreq_2 0 limEsp_2])
title('Teste 1: Espectro de Amplitude unilateral - Eixo Y')
xlabel('f (Hz)')
ylabel('|Gs|')

%pause
figure(12)
plot(f_t1,P1_t1_z)
axis([0 mFreq_2 0 limEsp_2])
title('Teste 1: Espectro de Amplitude unilateral - Eixo Z')
xlabel('f (Hz)')
ylabel('|Gs|')





%Calculo da frequencia e amplitude mximas

%Teste2:
%Eixo X
[ampl,M] = max(P1_t2_x);
ampl_2X = ampl;
freqMax_2X = f_t2(1,M);

%Eixo Y
[ampl,M] = max(P1_t2_y);
ampl_2Y = ampl;
freqMax_2Y = f_t2(1,M);

%Eixo Z
[ampl,M] = max(P1_t2_z);
ampl_2Z = ampl; 
freqMax_2Z = f_t2(1,M);
 
%Teste1:
%Eixo X
[ampl,M] = max(P1_t1_x);
ampl_1X = ampl;
freqMax_1X = f_t1(1,M);

%Eixo Y
[ampl,M] = max(P1_t1_y);
ampl_1Y = ampl;
freqMax_1Y = f_t1(1,M);
 
%Eixo Z
[ampl,M] = max(P1_t1_z);
ampl_1Z = ampl;
freqMax_1Z = f_t1(1,M);

%Condensa os dados em um array
AmplFreq = ["Eixo" "Frequencia" "Amplitude"; " " "Teste 2" " " ;
    "X2" freqMax_2X ampl_2X ; "Y2" freqMax_2Y ampl_2Y ; "Z2" freqMax_2Z ampl_2Z;
     " " "Teste 1" " " ;
     "X1" freqMax_1X ampl_1X ; "Y1" freqMax_1Y ampl_1Y ; "Z1" freqMax_1Z ampl_1Z];
 






